﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using KairoEngine.Utility;
using Sirenix.OdinInspector;
using KairoEngine.Core;

namespace KairoEngine.Statistics
{
    [HideMonoScript]
    public class StatisticElapsedTime : MonoBehaviour
    {
        public string statisticName = "";
        [ReadOnly] public string elapsedTime;

        [HorizontalGroup()] public bool unscaledDeltaTime = true;
        [HorizontalGroup()] public bool resetOnStart = true;

        void Start()
        {
            if(resetOnStart) Statistics.GetData(statisticName).Reset();
        }

        void Update()
        {
            if(unscaledDeltaTime)
            {
                Statistics.GetData(statisticName).AddTime(Time.unscaledDeltaTime);
            }
            else
            {
                Statistics.GetData(statisticName).AddTime(Time.deltaTime);
            }
            float time = Statistics.GetData(statisticName).GetTime();
            elapsedTime = KairoEngine.Core.Utilities.TimeToString(time);
        }
    }
}

